searchNodes=[{"ref":"Scisco.Query.html","title":"Scisco.Query","type":"behaviour","doc":"Easy pagination/sorting/filtering. Use this module to provide the default Scisco query interface: defmodule MyQuery do use Scisco.Query def base_queryable(), do: MySchema def repo(), do: MyRepo end and then call it from outside: MyQuery.list(%{page: %{number: 3, size: 10}, filter: %{&quot;foo&quot; =&gt; &quot;bar&quot;}, sort: &quot;-baz&quot;}) Pagination The query module supports by default two pagination strategies: the &quot;classic paginator&quot; style (with :size and :number keys - :number defaulting to 1) and the &quot;raw paginator&quot; style (with :limit and :offset keys - :offset defaulting to 0). Sorting By default any string in the sort key will enforce sorting the queryable by the corresponding field of the queryable - descending if the string starts with &quot;-&quot;, ascending otherwise. One can implement additional clauses that respect the sort_callback typespec. The clauses will always receive :asc or :desc depending on whether the original sort param starts with &quot;-&quot;. defmodule MyQuery do use Scisco.Query def base_queryable(), do: MySchema def repo(), do: MyRepo def sort(queryable, {:some_key, :asc}) def sort(queryable, {:some_key, :desc}) end Filtering By default any key in the filter map will be converted into an exact match of the corresponding field of the queryable. One can implement additional clauses that respect the filter_callback typespec. defmodule MyQuery do use Scisco.Query def base_queryable(), do: MySchema def repo(), do: MyRepo def filter(queryable, {:some_key, value}) end"},{"ref":"Scisco.Query.html#c:base_queryable/0","title":"Scisco.Query.base_queryable/0","type":"callback","doc":"Needs to be implemented by the module, returning an initial queryable for pagination etc."},{"ref":"Scisco.Query.html#c:filter/2","title":"Scisco.Query.filter/2","type":"callback","doc":"Implements specific filtering behavior. Falls back to match the term with the field"},{"ref":"Scisco.Query.html#filter/3","title":"Scisco.Query.filter/3","type":"function","doc":"Performs an actual filtering."},{"ref":"Scisco.Query.html#paginate/2","title":"Scisco.Query.paginate/2","type":"function","doc":"Performs an actual pagination."},{"ref":"Scisco.Query.html#c:repo/0","title":"Scisco.Query.repo/0","type":"callback","doc":"Needs to be implemented by the module, returning the Ecto Repo with which to actually execute the queries."},{"ref":"Scisco.Query.html#c:sort/2","title":"Scisco.Query.sort/2","type":"callback","doc":"Implements specific sorting behavior. Falls back to sorting by the given field"},{"ref":"Scisco.Query.html#sort/3","title":"Scisco.Query.sort/3","type":"function","doc":"Performs an actual sorting."},{"ref":"Scisco.Query.html#t:filter_callback/0","title":"Scisco.Query.filter_callback/0","type":"type","doc":""},{"ref":"Scisco.Query.html#t:filter_param/0","title":"Scisco.Query.filter_param/0","type":"type","doc":""},{"ref":"Scisco.Query.html#t:page_param/0","title":"Scisco.Query.page_param/0","type":"type","doc":""},{"ref":"Scisco.Query.html#t:params/0","title":"Scisco.Query.params/0","type":"type","doc":"The map representing the query params."},{"ref":"Scisco.Query.html#t:sort_callback/0","title":"Scisco.Query.sort_callback/0","type":"type","doc":""},{"ref":"Scisco.Query.html#t:sort_param/0","title":"Scisco.Query.sort_param/0","type":"type","doc":""},{"ref":"Scisco.Utils.html","title":"Scisco.Utils","type":"module","doc":""},{"ref":"Scisco.Utils.html#k2a/1","title":"Scisco.Utils.k2a/1","type":"function","doc":"Convert key/value pairs into atom/value pairs"},{"ref":"Scisco.Utils.html#normalize_params/1","title":"Scisco.Utils.normalize_params/1","type":"function","doc":"Normalize params into a map fulfilling the Scisco.Query.params() type."},{"ref":"Scisco.Utils.html#to_atom?/1","title":"Scisco.Utils.to_atom?/1","type":"function","doc":"Convert strings to atoms, keeps atoms."},{"ref":"Scisco.Utils.html#to_int?/1","title":"Scisco.Utils.to_int?/1","type":"function","doc":"Convert strings to integers, keeps integers."},{"ref":"readme.html","title":"Scisco","type":"extras","doc":"Scisco Easy query builder for Ecto. Pronounciation: ʃːisko (Shisko), which is a synonym of &quot;quaero&quot;. This package implements a simplified behavior for querying Ecto schemas, based on a common browser &lt;-&gt; API &lt;-&gt; database set of functions. A module implementing it will have two public functions: list/1 and get_page_count/1, both accepting a map with the same keys: :page, :filter and :sort. The semantics of the parameters are strongly inspired by JSON:API. See Scisco.Query for more information."},{"ref":"readme.html#installation","title":"Scisco - Installation","type":"extras","doc":"The package can be installed by adding scisco to your list of dependencies in mix.exs: def deps do [ {:scisco, &quot;~&gt; 0.1.0&quot;} ] end The docs can be found at https://hexdocs.pm/scisco."}]